//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "DeleteBackupDialogForm.h"
using namespace std;
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmDeleteBackupDialog *frmDeleteBackupDialog;
//---------------------------------------------------------------------------
__fastcall TfrmDeleteBackupDialog::TfrmDeleteBackupDialog(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
TModalResult TfrmDeleteBackupDialog::ShowMessage(
	const std::vector<TBackupUnit*>& punits)
{
	auto_ptr<TfrmDeleteBackupDialog> frm(new TfrmDeleteBackupDialog(NULL));
	for (size_t i= 0; i<punits.size(); ++i){
		TListItem* item= frm->lsvUnits->Items->Add();
		item->Caption= punits[i]->BaseDirPath().c_str();
		item->SubItems->Add(PTimeToJapanese(punits[i]->Time()).c_str());
		item->SubItems->Add(punits[i]->Name().c_str());
	}
	return frm->ShowModal();
}

//---------------------------------------------------------------------------
