//---------------------------------------------------------------------------
#include "Precompiled.h"
#pragma hdrstop

#include "ProcessForm.h"
#include "Exceptions.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmProcess *frmProcess;
//---------------------------------------------------------------------------
__fastcall TfrmProcess::TfrmProcess(TComponent* Owner)
		: TForm(Owner), bStopRequired_(false)
{
}
//---------------------------------------------------------------------------
void TfrmProcess::ShowMessage(const AnsiString& sMsg,
	const AnsiString& sSubMsg, int nCurrent, int ctAll)//bZ[W\
{
	if (sMsg!=sCurMsg_){
		lblMsg->Caption= sMsg;
		sCurMsg_= sMsg;
	}
	if (sSubMsg!=sCurSubMsg_){
		lblSubMsg->Caption= sSubMsg;
		sCurSubMsg_= sSubMsg;
	}
	lblN->Caption= IntToStr(nCurrent)+"/"+IntToStr(ctAll);
	pgbProg->Position= (ctAll>0)?(int)((float)nCurrent/ctAll*100):0;
}

//---------------------------------------------------------------------------
void TfrmProcess::ThrowIfStopped()//~{^ĂO
{
  Application->ProcessMessages();
  if (bStopRequired_)
    throw EStoppedException();
}

//---------------------------------------------------------------------------
void __fastcall TfrmProcess::btnStopClick(TObject *Sender)
{
	bStopRequired_= true;
}
//---------------------------------------------------------------------------


void __fastcall TfrmProcess::FormShow(TObject *Sender)
{
//	Position= poScreenCenter;
  ShowMessage("...", "", 0, 0);
  bStopRequired_= false;
}
//---------------------------------------------------------------------------

