//---------------------------------------------------------------------------
#ifndef ResultFormH
#define ResultFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include "VCLCommon.h"
//---------------------------------------------------------------------------
class TfrmResult : public TForm
{
__published:	// IDE Ǘ̃R|[lg
		TStatusBar *stbMain;
	TPanel *pnlPlaces;
	TScrollBox *scbPlaces;
	TPaintBox *pbxPlaces;
	TPanel *pnlPlacesHead;
	TPanel *pnlCheck;
	TPanel *pnlLine;
	TPanel *pnlPos;
	TPanel *pnlFile;
	TEdit *edtPlacesDummy;
	TPanel *pnlReplacing;
	TPopupMenu *pmnPlaces;
	TMenuItem *mniView;
	TImageList *imlCheck;
	TPanel *Panel2;
	TComboBox *cmbReplacing;
	TLabel *lblReplacing;
	TPanel *Panel4;
	TButton *btnReplace;
	TMenuItem *mniCopyPath;
	TButton *btnAllOn;
	TButton *btnAllOff;
  TButton *btnConfirm;
  TMenuItem *mniEditor;
  TButton *btnReplacingEdit;
	void __fastcall pbxPlacesPaint(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall scbPlacesEnter(TObject *Sender);
	void __fastcall scbPlacesExit(TObject *Sender);
	void __fastcall edtPlacesDummyKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
	void __fastcall pbxPlacesMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall scbPlacesResize(TObject *Sender);
	void __fastcall btnReplaceClick(TObject *Sender);
	void __fastcall btnConfirmClick(TObject *Sender);
	void __fastcall pnlPlacesHeadMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall pnlPlacesHeadMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
	void __fastcall pnlPlacesHeadMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall mniViewDblClick(TObject *Sender);
	void __fastcall pbxPlacesMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall FormMouseWheelDown(TObject *Sender, TShiftState Shift,
          TPoint &MousePos, bool &Handled);
	void __fastcall FormMouseWheelUp(TObject *Sender, TShiftState Shift,
          TPoint &MousePos, bool &Handled);
	void __fastcall mniCopyPathClick(TObject *Sender);
	void __fastcall btnAllOnClick(TObject *Sender);
	void __fastcall btnAllOffClick(TObject *Sender);
  void __fastcall mniEditorClick(TObject *Sender);
  void __fastcall btnReplacingEditClick(TObject *Sender);
  void __fastcall pmnPlacesPopup(TObject *Sender);
private:	// [U[錾
	static const int ctPlaceColumn_= 4;//ʒuXg̗
	static const int nPlacePlaceColumn_= 1;//ʒuXǵuʒuv̗̔ԍ
	static const int wtPlaceColumnMin_= 32;//ʒuXg̗̍ŏ

	int htPlaceLine_;//ʒuXg1s̍
	TPanel* pnlsPlaceHead[4];//ʒuXg̃wb_
	int nFocusPlace_;//Ԗڂ̈ʒuɃtH[JX邩
	bool bPlaceFocusVisible_;//ʒutH[JX\邩
	int nResizingPlaceColumn_;//TCYύẌʒuXg̔ԍ
	int xPlaceColumnResize_;//ʒuXg̃TCYύX̃NbNʒu

	//ʒu\̃LbV
	int nCacheBegin_;//Jnʒuԍ
	int nCacheEnd_;//Iʒuԍ
	std::auto_ptr<TGBitmap> bmCache_;//LbViȂNULLj

	void SetGUITexts();//GUĨeLXgݒ
  void SetPlaceFocus(int i);//ʒutH[JX̐ݒ
  void DrawPlaceFocus();//ʒutH[JX`
	void SwitchPlaceSelect(int n);//ʒȗI𔽓]
	void SetAllSelect(bool b);//SđIorSđI
  void OpenEditor(int nPlace);//OR}hs

public:		// [U[錾
		__fastcall TfrmResult(TComponent* Owner);
	void OnPlacesUpdate(bool bAdd);
		//ʒuXgXVꂽ
		//	bAdd: ʒuǉꂽ
  void RedrawPlace(int nBegin, int nEnd);
  	//[nBegin,nEnd)Ԗڂ̈ʒu̕\XV
  void DrawPlaceText(const std::string& s, int nPlace, int xLeft,
  		int xRight, bool bRight);
  	//ʒuXg̃eLXg`

};
//---------------------------------------------------------------------------
extern PACKAGE TfrmResult *frmResult;
//---------------------------------------------------------------------------
#endif
