//---------------------------------------------------------------------------
/*
         PerlIK\eBeB reg_manager 1.7  by Gimite s

  K\APerlۂȒPɈNXB

  Gimite s <gimite@mx12.freecom.ne.jp>
  
*/
//---------------------------------------------------------------------------
#ifndef GIMITE_reg_managerH
#define GIMITE_reg_managerH
//---------------------------------------------------------------------------
#include <cstddef>
#include <string>
#include <list>
#include <vector>
#include <iterator>
#include <locale>
#include <boost/config.hpp>
#include <boost/array.hpp>
#include <boost/regex.hpp>
#include <boost/version.hpp>
//---------------------------------------------------------------------------
//BCB6ŁAtolowerȂǂlocaleɂƂo[WOstd
//`ĂȂwork around

#if defined(__BORLANDC__) && defined(__SGI_STL_PORT) \
    && __SGI_STL_PORT==0x450 && !defined(GIMITE_LOCALED_CTYPE_FUNCS)

namespace std{
  using _STL::isdigit;
  using _STL::tolower;
  using _STL::toupper;
}

#endif
//---------------------------------------------------------------------------
namespace gimite{
//---------------------------------------------------------------------------
typedef unsigned long ulong;
//---------------------------------------------------------------------------
//K\up̓
template <class Char>
struct def_regex_replace_traits
{
  typedef Char char_type;

  enum{
    newline_char= (ulong)'\n',
    tab_char= (ulong)'\t',
    escape_char= (ulong)'\\',
    n_char= (ulong)'n',
    t_char= (ulong)'t',
    l_char= (ulong)'l',
    L_char= (ulong)'L',
    u_char= (ulong)'u',
    U_char= (ulong)'U',
    E_char= (ulong)'E'
  };
  
  static bool isdigit(char_type c){
    return std::isdigit(c, std::locale());
  }
  static char_type tolower(char_type c){
    return std::tolower(c, std::locale());
  }
  static char_type toupper(char_type c){
    return std::toupper(c, std::locale());
  }
  static int toi(char_type c){ return int(c) - int('0'); }

};

//---------------------------------------------------------------------------
//K\̂߂̃NX
template <
  class Char,
  class Traits= boost::regex_traits<Char>,
  class RTraits= def_regex_replace_traits<Char> >
class basic_reg_manager
{
public:
  typedef Char char_type;
  typedef Traits traits;
  typedef RTraits rtraits;
  typedef std::basic_string<char_type> string_type;
  typedef typename string_type::const_iterator iterator;
#if BOOST_VERSION<103100 || defined(BOOST_REGEX_V3)
  typedef boost::reg_expression<char_type, traits> reg_exp_t;
#else
  typedef boost::basic_regex<char_type, traits> reg_exp_t;
#endif
  typedef boost::match_results<iterator> match_results;
  typedef unsigned long additional_flag_type;
  enum{//additional_flag_type
    af_global= 1,
  };
  enum{saved_strs_count= 10};
    //Boost 1.28ȑOł́Ǎ𒴂OQƕ͕ۑȂ

  //v
  bool match(const string_type& str,
      const string_type& exp, const char* flags= ""){
    sreses_.resize(1);
    bool b= boost::regex_match(str, sreses_.front().res_,
      reg_exp_t(exp, make_reg_flags(flags)));
    sreses_.front().save_strs();
    return b;
  }
  //
  unsigned int search(const string_type& str,
      const string_type& exp, const char* flags= ""){
    if (make_additional_flags(flags)&af_global){
      sreses_.clear();
      return boost::regex_grep(searcher(*this), str.begin(), str.end(),
        reg_exp_t(exp, make_reg_flags(flags)));
    }else{
      sreses_.resize(1);
      bool b= boost::regex_search(str, sreses_.front().res_,
        reg_exp_t(exp, make_reg_flags(flags)));
      sreses_.front().save_strs();
      return b;
    }
  }
  //uistruj
  unsigned int replace(string_type& str,
      const string_type& exp, const string_type& new_exp,
      const char* flags= ""){
    const string_type src= str;
    replacer rep(str, src, new_exp, make_additional_flags(flags));
    return boost::regex_grep(replacer_caller(rep), src.begin(), src.end(),
      reg_exp_t(exp, make_reg_flags(flags)));
  }
  //uiuʂԂj
  string_type substitute(const string_type& str,
      const string_type& exp, const string_type& new_exp,
      const char* flags= ""){
    string_type result= str;
    replace(result, exp, new_exp, flags);
    return result;
  }
  //
  std::vector<string_type> split(string_type& str, const string_type& exp, 
      const char* flags, std::size_t max_split){
    std::vector<string_type> strs;
    boost::regex_split(std::back_inserter(strs), str,
      reg_exp_t(exp, make_reg_flags(flags)), boost::match_default, max_split);
    return strs;
  }
  //
  std::vector<string_type> split(string_type& str, const string_type& exp, 
      const char* flags= ""){
    std::vector<string_type> strs;
    boost::regex_split(std::back_inserter(strs), str,
      reg_exp_t(exp, make_reg_flags(flags)));
    return strs;
  }
  //O[oȌ̎̌ʂ
  bool next(){
    if (!sreses_.empty()) sreses_.pop_front();
    return !sreses_.empty();
  }
  //iԖڂ̑OQƂ̕
  string_type str(int i= 0)const{
    if (sreses_.empty()) return string_type();
    else if (i<sreses_.front().strs_.size()) return sreses_.front().strs_[i];
    else return string_type();
  }
  //iԖڂ̑OQƂ̒
  typename match_results::difference_type length(int i= 0)const{
    if (sreses_.empty()) return 0;
    else return sreses_.front().res_.length(i);
  }
  //iԖڂ̑OQƂ̈ʒu
  typename match_results::difference_type position(unsigned int i= 0)const{
    if (sreses_.empty()) return -1;
    else return sreses_.front().res_.position(i);
  }

private:
  class replacer
  {
  public:
    replacer(string_type& s, const string_type& src,
        const string_type& new_exp, additional_flag_type f)
        : s_(s), src_(src), new_exp_(new_exp), f_(f), pos_(0){
      s_= string_type();
    }
    ~replacer(){
      s_+=src_.substr(pos_);
    }
    bool operator()(const match_results& res){
      s_+=src_.substr(pos_, res.position()-pos_);
      int cstate= 0;
      int ccount= -1;
      for (typename string_type::size_type pos= 0; pos<new_exp_.length(); ++pos){
        string_type s;
        if (new_exp_[pos]==rtraits::escape_char){
          ++pos;
          if (pos>=new_exp_.length()) break;
          if (rtraits::isdigit(new_exp_[pos])){
            s+= res.str(rtraits::toi(new_exp_[pos]));
          }else{
            switch (new_exp_[pos]){
              case rtraits::escape_char: s+= rtraits::escape_char; break;
              case rtraits::n_char: s+= rtraits::newline_char; break;
              case rtraits::t_char: s+= rtraits::tab_char; break;
              case rtraits::l_char: cstate= 1; ccount= 2; break;
              case rtraits::L_char: cstate= 1; ccount= 0; break;
              case rtraits::u_char: cstate= 2; ccount= 2; break;
              case rtraits::U_char: cstate= 2; ccount= 0; break;
              case rtraits::E_char: cstate= 0; break;
              default: s+= new_exp_[pos]; break;
            }
          }
        }else{
          s+= new_exp_[pos];
        }
        switch (cstate){
          case 0: s_+= s; break;
          case 1:{
              for (typename string_type::size_type i= 0; i<s.length(); ++i)
                s_+= rtraits::tolower(s[i]);
            }
            break;
          case 2:{
              for (typename string_type::size_type i= 0; i<s.length(); ++i)
                s_+= rtraits::toupper(s[i]);
            }
            break;
        }
        if (ccount>0){
          --ccount;
          if (ccount==0) cstate= 0;
        }
      }
      pos_= res.position()+res.length();
      return f_&af_global;
    }

  private:
    string_type& s_;
    const string_type& src_;
    const string_type& new_exp_;
    additional_flag_type f_;
    typename match_results::difference_type pos_;

  };

  class replacer_caller
  {
  public:
    explicit replacer_caller(replacer& rep): rep_(rep){}
    bool operator()(const match_results& res){return rep_(res);}

  private:
    replacer& rep_;

  };

  class searcher
  {
  public:
    explicit searcher(basic_reg_manager& rm): rm_(rm){}
    bool operator()(const match_results& res){
      rm_.sreses_.push_back(saved_results(res));
      return true;
    }

  private:
    basic_reg_manager& rm_;

  };
  friend class searcher;

  struct saved_results{//OQƕ̃obNAbvtmatch_results
    match_results res_;
    std::vector<string_type> strs_;//OQƕ
    saved_results(){}
    saved_results(const match_results& res): res_(res){
      save_strs();
    }
    void save_strs(){
#if BOOST_VERSION>=102900
      strs_.resize(res_.size());
#else
      strs_.resize(saved_strs_count);
#endif
      for (std::size_t i= 0; i<strs_.size(); ++i)
        strs_[i]= res_.str(i);
    }
  };

  std::list<saved_results> sreses_;//Ǩ

  typename reg_exp_t::flag_type make_reg_flags(const char* cs){
    typename reg_exp_t::flag_type f= boost::regbase::normal;
    for (const char* p= cs; *p; ++p){
      switch (*p){
        case 'i': f|= boost::regbase::icase; break;
      }
    }
    return f;
  }
  additional_flag_type make_additional_flags(const char* cs){
    additional_flag_type f= 0;
    for (const char* p= cs; *p; ++p){
      switch (*p){
        case 'g': f|= af_global; break;
      }
    }
    return f;
  }
  std::size_t strlen(const char_type* s){
    std::size_t len;
    for (len= 0; *s; ++s, ++len) ;
    return len;
  }

};

typedef basic_reg_manager<char> reg_manager;
typedef basic_reg_manager<wchar_t> wreg_manager;
//---------------------------------------------------------------------------
}//namespace gimite
//---------------------------------------------------------------------------
#endif
