//---------------------------------------------------------------------------
#ifndef StrProcessH
#define StrProcessH
//---------------------------------------------------------------------------
#include <string>
#include <cstring>
#include "Win32Common.h"
#include "Definitions.h"
//---------------------------------------------------------------------------
template <class T>
std::basic_string<T> EscapeForRegex(const std::basic_string<T>& ts);
  //ts𐳋K\pɃGXP[v
template <class T>
std::basic_string<T> Unescape(const std::basic_string<T>& ts);
  //ts̃GXP[v
template <class T>
bool IsCAlnum(T tc)
    {return std::isalnum(tc) || tc==T((unsigned char)('_'));}
  //At@xbgA_XRA
template <class T>
std::basic_string<T> ToTstr(const char* cs);
  //csbasic_string<T>ɕϊ(*1)
std::string ToSjis(const std::string& ts){return ts;}
std::string ToSjis(const std::wstring& ts){return Utf16ToSjis(ts);}
	//tsS-JISɕϊ

//*1	2oCgɂ͔ΉB
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//ev[g֐̎
//---------------------------------------------------------------------------
template <class T>
std::basic_string<T> EscapeForRegex(const std::basic_string<T>& ts)
  //ts𐳋K\pɃGXP[v
{
	const char* cs1= "\n\t\a\f\r\v";
  const char* cs2= "ntafrv";
  const char* cs3= ".*?+(){}[]^$|\\";
  	std::basic_string<T> tsR;
  for (std::basic_string<T>::size_type pos= 0; pos<ts.length(); ++pos){
    char c= char(ts[pos]);
    if (ts[pos]!=T(uchar(c))){
    	tsR+= ts[pos];
    }else{
      const char* p1= std::strchr(cs1, c);
      if (p1){
        tsR+= T(uchar('\\'));
        tsR+= T(uchar(cs2[p1-cs1]));
      }else{
        if (std::strchr(cs3, c)) tsR+= T(uchar('\\'));
        tsR+= ts[pos];
      }
    }
  }
  return tsR;
}

//---------------------------------------------------------------------------
template <class T>
std::basic_string<T> Unescape(const std::basic_string<T>& ts)
  //ts̃GXP[v
{
	const char* cs1= "\n\t\a\f\r\v";
  const char* cs2= "ntafrv";
  	std::basic_string<T> tsR;
  for (std::basic_string<T>::size_type pos= 0; pos<ts.length(); ++pos){
    if (ts[pos]=='\\'){
    	++pos;
    	if (pos<ts.length()){
      	const char* p2= std::strchr(cs2, ts[pos]);
        if (p2) tsR+= T(uchar(cs1[p2-cs2]));
        else tsR+= ts[pos];
      }else{
      	tsR+= T(uchar('\\'));
      }
    }else{
    	tsR+= ts[pos];
    }
  }
  return tsR;
}

//---------------------------------------------------------------------------
template <class T>
std::basic_string<T> ToTstr(const char* cs)
  //csbasic_string<T>ɕϊ(*1)
{
	std::basic_string<T> ts;
	for (const char* p= cs; *p; ++p) ts+= T((unsigned char)(*p));
  return ts;
}

//---------------------------------------------------------------------------
//seLXg(s\r\n)"\\n"A"\\t"geLXgɕϊ
std::string EscapeMultiLine(const std::string& s);
//"\\n"A"\\t"geLXg𕡐seLXg(s\r\n)ɕϊ
std::string UnescapeMultiLine(const std::string& s);
//---------------------------------------------------------------------------
#endif
