//---------------------------------------------------------------------------
#ifndef ViewFormH
#define ViewFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include "SonEdit.hpp"
#include "File.h"
#include "Place.h"
//---------------------------------------------------------------------------
class TfrmView : public TForm
{
__published:	// IDE Ǘ̃R|[lg
		TMainMenu *mnuMain;
		TMenuItem *File1;
		TMenuItem *mniSave;
		TMenuItem *Edit1;
		TMenuItem *mniCut;
		TMenuItem *mniCopy;
		TMenuItem *mniPaste;
		TStatusBar *stbMain;
	TSonEdit *sedFile;
	TMenuItem *mniForm;
	TMenuItem *mniWrap;
	TMenuItem *mniUndo;
	TMenuItem *N1;
		void __fastcall sedFile1Change(TObject *Sender);
		void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
		void __fastcall mniSaveClick(TObject *Sender);
		void __fastcall mniCutClick(TObject *Sender);
		void __fastcall mniCopyClick(TObject *Sender);
		void __fastcall mniPasteClick(TObject *Sender);
		void __fastcall sedFileSelectionChange(TObject *Sender);
	void __fastcall mniWrapClick(TObject *Sender);
	void __fastcall Edit1Click(TObject *Sender);
	void __fastcall mniUndoClick(TObject *Sender);
private:	// [U[錾
	std::auto_ptr<TFile<char> > fileSB_;//SB̎̃t@C
	std::auto_ptr<TFile<wchar_t> > fileMB_;//MB̎̃t@C
	std::string path;//I[ṽt@CpX
	bool bRefresh;//XV̕Kv
	bool bChanged;//ύX

	void LoadFromFile(const std::string& path);//t@C烍[h
	void ShowText();//[heLXg\
	void GetAnsiPosition(const TAbstractPlace* place,
			int& nLine, int& pos, int& len);
		//ẅʒuAnsiStringł̏ꏊ߂
	template <class T>
	void GetAnsiPosition(const TPlace<T>* place,
			const std::basic_string<T>& tsCont, int& nLine, int& pos, int& len);
		//ẅʒuAnsiStringł̏ꏊ߂
	void SaveToFile();//t@Cɕۑ
	void RefreshWrap();//܂Ԃ̗L𔽉f

public:		// [U[錾
	__fastcall TfrmView(TComponent* Owner);
	void ShowPlace(int nPlace);
		//(ԍ)t@CI[vĔʒu
	bool Save(bool bChk, bool bCancelable);
		//t@C̕ύX̕ۑiLZfalsej
		//	bChk: ۑ邩mF
		//	bCancelable: LZ\
	void ForceToClose();//K

};
//---------------------------------------------------------------------------
extern PACKAGE TfrmView *frmView;
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//ev[g֐̎
//---------------------------------------------------------------------------
template <class T>
void TfrmView::GetAnsiPosition(const TPlace<T>* place,
		const std::basic_string<T>& tsCont, int& nLine, int& pos, int& len)
  //ẅʒuAnsiStringł̏ꏊ߂
{
	typedef std::basic_string<T> TString;
  std::size_t pos1= 0;
  for (int i= 0; i<place->LineNumber(); ++i, ++pos1){
  	pos1= tsCont.find(T(uchar('\n')), pos1);
    if (pos1==TString::npos){
      pos1= tsCont.length();
    	break;
    }
	}
	TString tsLineFow= tsCont.substr(pos1, place->Position());
	int ctFowReturn= std::count(tsLineFow.begin(), tsLineFow.end(),
		T(uchar('\n')));
	std::size_t posCurLineBg=
		(ctFowReturn==0)? 0:tsLineFow.find_last_of('\n')+1;
	std::string tsHit= place->Str();
	pos= ToSjis(tsLineFow.substr(posCurLineBg)).length();
	nLine= place->LineNumber()+ctFowReturn;
	len= tsHit.length()+std::count(tsHit.begin(), tsHit.end(), T(uchar('\n')));
		//\n\r\nɂȂĂ̂ŁA\n̐L΂
}

//---------------------------------------------------------------------------
#endif
