//---------------------------------------------------------------------------
/*
                 ͈̓`FbNtxN^  ass_vector  Ver.1.1

  operator[]Ȃǂ̃o֐ŁAYCe[^͈̔̓`FbNs
  std::vectorłB͈̓`FbNassertōs߁ANDEBUGdefine
  ɂȂ܂B

                                    Gimite s <gimite@mx12.freecom.ne.jp>

*/
//---------------------------------------------------------------------------
#ifndef GIMITE_ass_vectorH
#define GIMITE_ass_vectorH
//---------------------------------------------------------------------------
#include <cassert>
#include <vector>
//---------------------------------------------------------------------------
namespace gimite{
//---------------------------------------------------------------------------
template <class T, class Allocator= std::allocator<T> >
class ass_vector: public std::vector<T, Allocator>
{
  typedef std::vector<T, Allocator> base_t;
  
public:
  typedef typename base_t::reference reference;
  typedef typename base_t::const_reference const_reference;
  typedef typename base_t::size_type size_type;
  typedef typename base_t::iterator iterator;
  typedef typename base_t::const_iterator const_iterator;

  explicit ass_vector(const Allocator& alloc= Allocator()): base_t(alloc){}
  explicit ass_vector (size_type size, const T& val= T(), 
      const Allocator& alloc= Allocator())
    : base_t(size, val, alloc){}
  template <class InputIterator>
  ass_vector (InputIterator first, InputIterator last, 
      const Allocator& alloc= Allocator ())
    : base_t(first, last, alloc){}
  
  reference operator[](size_type pos){
    assert(pos >= 0 && pos < this->size());
    return base_t::operator[](pos);
  }
  const_reference operator[](size_type pos)const{
    assert(pos >= 0 && pos < this->size());
    return base_t::operator[](pos);
  }
  reference back(){
    assert(this->size() > 0);
    return base_t::back();
  }
  const_reference back()const{
    assert(this->size() > 0);
    return base_t::back();
  }
  iterator erase(iterator pos){
    assert(pos >= this->begin() && pos < this->end());
    return base_t::erase(pos);
  }
  iterator erase(iterator first, iterator last){
    assert(this->begin() <= first && first<=last && last <= this->end());
    return base_t::erase(first, last);
  }
  reference front(){
    assert(this->size() > 0);
    return base_t::front();
  }
  const_reference front()const{
    assert(this->size() > 0);
    return base_t::front();
  }
  iterator insert(iterator pos, const T& x){
    assert(pos >= this->begin() && pos <= this->end());
    return base_t::insert(pos, x);
  }
  void insert(iterator pos, size_type n, const T& x){
    assert(pos >= this->begin() && pos <= this->end());
    base_t::insert(pos, n, x);
  }
  template <class InputIterator>
  void insert(iterator pos, InputIterator first, InputIterator last){
    assert(pos >= this->begin() && pos <= this->end());
    base_t::insert(pos, first, last);
  }
  void pop_back(){
    assert(this->size() > 0);
    base_t::pop_back();
  }

};

//---------------------------------------------------------------------------
}//namespace gimite
//---------------------------------------------------------------------------
#endif
