//---------------------------------------------------------------------------
#include <typeinfo>
//---------------------------------------------------------------------------
namespace gimite{
//---------------------------------------------------------------------------
//^CvXg̏I[Ȃǂ\^
struct null_type;
//---------------------------------------------------------------------------
//^CvXǧɂȂu^̑΁v
template <class Car, class Cdr= null_type>
struct type_cons{
  typedef Car car;
  typedef Cdr cdr;
};
//---------------------------------------------------------------------------
//^CvXǧ^̃TCY̍ől߂RpC^C֐
template <class TL>
struct max_size_of
{
  enum{
    car_size= sizeof(typename TL::car),
    cdr_size= max_size_of<typename TL::cdr>::value,
    value= car_size>cdr_size? car_size : cdr_size
  };
};
//---------------------------------------------------------------------------
//max_size_of̍ċȀI
template <>
struct max_size_of<null_type>
{
  enum{
    value= 0
  };
};
//---------------------------------------------------------------------------
//type_identifier_impl̋ʃC^tF[X
struct type_identifier
{
  virtual void destruct(const void* p)= 0;
  virtual void copy(void* dest, const void* src)= 0;
  virtual const std::type_info& type_info()= 0;
};
//---------------------------------------------------------------------------
//^ɂĂ̏/𓮓Iɓ邽߂̂
template <class T>
struct type_identifier_impl: type_identifier
{
  //VOg̃CX^XԂ
  static type_identifier* instance(){
    static type_identifier_impl inst;
    return &inst;
  }
  //fXgN^
  virtual void destruct(const void* p){
    static_cast<const T*>(p)->~T();
  }
  //Rs[RXgN^
  virtual void copy(void* dest, const void* src){
    new(static_cast<T*>(dest)) T(*static_cast<const T*>(src));
  }
  //RTTI
  virtual const std::type_info& type_info(){
    return typeid(T);
  }
};
//---------------------------------------------------------------------------
//^CvXgɎw̌^L鎖RpC^CɃ`FbN
template <class T>
struct type_checker
{
  void check()const{}
};
//---------------------------------------------------------------------------
//^CvXg̑SĂ̌^Tɂtype_checker<T>pNX
template <class TL>
struct type_checkers
  : type_checker<typename TL::car>, 
    type_checkers<typename TL::cdr>
{};
//---------------------------------------------------------------------------
//type_ckeckers̍ċȀI
template <>
struct type_checkers<null_type>
{};
//---------------------------------------------------------------------------
//^Sȋp
template <class TL>
class safe_union_base: type_checkers<TL>
{
public:
  //ftHgRXgN^
  safe_union_base(): type_id_(0){}
  //Rs[RXgN^
  safe_union_base(const safe_union_base& src): type_id_(src.type_id_){
    type_id_->copy(buffer_, src.buffer_);
  }
  //fXgN^
  ~safe_union_base(){
    if (type_id_) type_id_->destruct(buffer_);
  }
  //Zq
  safe_union_base& operator=(const safe_union_base& src){
    if (type_id_) type_id_->destruct(buffer_);
    type_id_= src.type_id_;
    type_id_->copy(buffer_, src.buffer_);
  }
  //w̌^̒lւ̎QƂԂiconstŁj
  template <class T>
  T& value(){
    if (!type_is<T>()){
      if (type_id_) type_id_->destruct(buffer_);
      type_id_= type_identifier_impl<T>::instance();
      new(buffer_) T();
    }
    return *reinterpret_cast<T*>(buffer_);
  }
  //w̌^̒lԂiconstŁj
  template <class T>
  const T value()const{
    if (!type_is<T>())
      return T();
    else
      return *reinterpret_cast<const T*>(buffer_);
  }
  //݂̒ľ^RTTIԂ
  const std::type_info& type_info()const{
    if (type_id_) return type_id_->type_info();
    else return typeid(void);
  }
  //݂̒ľ^TǂԂ
  template <class T>
  bool type_is()const{
    type_checker<T>::check();
    return type_id_==type_identifier_impl<T>::instance();
  }
  
private:
  enum{
    size_= max_size_of<TL>::value
  };
  type_identifier* type_id_;
  char buffer_[size_];
  
};
//---------------------------------------------------------------------------
//safe_union_basě^̎wȒPɂ́i4p[^Łj
template <class T0, class T1, class T2= null_type, class T3= null_type>
class safe_union
  : public safe_union_base<type_cons<T0, type_cons<T1,
      type_cons<T2, type_cons<T3> > > > >
{};
//---------------------------------------------------------------------------
//safe_union_basě^̎wȒPɂ́i3p[^Łj
template <class T0, class T1, class T2>
class safe_union<T0, T1, T2, null_type>
  : public safe_union_base<type_cons<T0, type_cons<T1, type_cons<T2> > > >
{};
//---------------------------------------------------------------------------
//safe_union_basě^̎wȒPɂ́i2p[^Łj
template <class T0, class T1>
class safe_union<T0, T1, null_type, null_type>
  : public safe_union_base<type_cons<T0, type_cons<T1> > >
{};
//---------------------------------------------------------------------------
}//namespace gimite
//---------------------------------------------------------------------------
